/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#include <time.h>

#include "object.h"
#include "thread.h"
#include "queue.h"

#ifndef _JOB_H
#define _JOB_H 1

#define SCHEDULE_SLEEP	(1 * 1000000) /* 1 second */

struct job_ctx;
struct job_ctx {
	thread_main_t	__job;
	thread_arg_t	__arg;
	bool		__fork;
	int		__every;
	time_t		__last;

	SLIST_ENTRY(job_ctx) __sle;
};


void schedule(void(*)(void*),void *,int,bool,bool);
void scheduler(void);

void test_job(void *);

#endif /* _JOB_H */
