/* ==========================================================================
 * SourceForge Snippet
 * --------------------------------------------------------------------------
 * Copyright (C) 2000  dyfet (SourceForge)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * --------------------------------------------------------------------------
 * Modified:
 * 	20010407 <wahern>- returns true or false
 * ==========================================================================
 */
#include <unistd.h>
#include <signal.h>
#include <sysexits.h>

#ifdef  SIGTSTP
#include <sys/file.h>
#include <sys/ioctl.h>
#endif

#include "common.h"
#include "pdetach.h"


/* normally included from paths.h */

#ifndef _PATH_TTY
#define _PATH_TTY "/dev/tty"
#endif


bool pdetach(void) {
	int pid;
	int fd;

	/* if we are started from init, no need to become daemon */
	if(getppid() == 1)
		return true;

#ifdef  SIGTTOU
	signal(SIGTTOU, SIG_IGN);
#endif
 
#ifdef  SIGTTIN
	signal(SIGTTIN, SIG_IGN);
#endif                                                                          

#ifdef  SIGTSTP
	signal(SIGTSTP, SIG_IGN);
#endif
 
	if((pid = fork()) < 0) {
		/* exit(EX_OSERR); */
		return false;
	} else if(pid > 0) {
		exit(0);
	}
 
#if defined(SIGTSTP) && defined(TIOCNOTTY)
	if(setpgid(0, getpid()) == -1) {
		/* exit(EX_OSERR); */
		return false;
	}

	if((fd = open(_PATH_TTY, O_RDWR)) >= 0) {
		ioctl(fd, TIOCNOTTY, NULL);
		close(fd);
	}
#else
	if(setpgrp() == -1) {
		/* exit(EX_OSERR); */
		return false;
	}

	signal(SIGHUP, SIG_IGN);
 
	if((pid = fork()) < 0) {
		/*exit(OS_ERR);*/
		return false;
	} else if(pid > 0) {
		exit(0);
	}

#endif                                                                                                                                                          

	return true;
}
