/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#include "thread.h"

#ifndef _SERVER_H
#define _SERVER_H 1

struct server;
typedef struct server server_t;

struct server {
	thread_t thread;
	long int server_id;
	void (*call_back)(int);
	int port;
	void (*set_sockopts)(int);
};


server_t *server_create(int,void (*)(int),void (*)(int));
void server_free(server_t *);
void __server_free(void *);

void server_run(server_t *);
void __server_run(void *);

#endif /* _SERVER_H */
