/* ==========================================================================
 * AnonNet - Anonymous Network Project
 * --------------------------------------------------------------------------
 * Copyright (C) 2001  William Ahern
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * ==========================================================================
 */

#ifndef _LINK_H
#define _LINK_H 1

#include <openssl/dh.h>
#include "common.h"
#include "packet.h"

struct link;
typedef struct link link_t;
typedef link_t *Link;

struct link {
	int sockfd;
	int hopid;

	unsigned char lflag;
	unsigned char nflag;

	unsigned char recvbuf[PACKET_SIZE];
	unsigned char sendbuf[PACKET_SIZE];
	bool (*readp)(Link);
	void (*writep)(Link);
	bool (*read)(Link,void *,int);
	bool (*write)(Link,void *,int);
	void (*free)(Link);
};

Link link_create(void);
void link_free(Link);

bool link_readp(Link);
void link_writep(Link);

bool link_read(Link,void *,int);
bool link_write(Link,void *,int);

#endif /* _LINK_H */
