#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <openssl/dh.h>
#include <openssl/bn.h>
#include <openssl/hmac.h>
#include <mcrypt.h>
#include "common.h"
#include "packet.h"
#include "link.h"
#include "crypt.h"

int main(int argc,char *argv[]) {
	int s, sd, i, b;
	struct sockaddr_in sin;
	const socklen_t saddr_size = (socklen_t)sizeof(struct sockaddr_in);
	short port;
	unsigned char buf[4096];
	unsigned char prf[2048];
	unsigned char *data;
	unsigned char *packet;
	unsigned char *p;
	unsigned char iv[20];
	unsigned char seed[128];
	unsigned char *cipher_key;
	unsigned char *hmac_key;
	DH *dh;
	MCRYPT td;
	unsigned short int sint;
	unsigned long int lint;
	Link link;

	td = mcrypt_module_open(MCRYPT_RIJNDAEL_128,NULL,MCRYPT_CBC,NULL);

	link = link_create();
	link->hopid = 0;

	port = (short)atoi(argv[1]);

	bzero(&sin,sizeof(saddr_size));
	sin.sin_family      = AF_INET;
	/*sin.sin_addr.s_addr = INADDR_LOOPBACK;*/
	sin.sin_port        = htons(port);

	inet_pton(AF_INET,"127.0.0.1",&sin.sin_addr);

	s = socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);

	if (connect(s,(struct sockaddr *)&sin,saddr_size) != 0) {
		printf("%s\n\n",strerror(errno));
		exit(1);
	}

	bzero(buf,4096);
	buf[0] = PACKET_LINK_INIT;
	buf[1] = htons(0);

	write(s,&buf[0],129);

	bzero(buf,4096);
	data = &buf[0];
	packet = &buf[2048];

	dh = DH_generate_parameters(128,2,NULL,NULL);
	DH_generate_key(dh);

	buf[0] = (BN_num_bytes(dh->p)-1);
	buf[1] = (BN_num_bytes(dh->g)-1);
	buf[2] = (BN_num_bytes(dh->pub_key)-1);
	buf[3] = 127;
	data = &buf[4];


	BN_bn2bin(dh->p,data);
	/* printf("Prime:\n%s\n",hex(data,BN_num_bytes(dh->p))); */
	data += 128;
	BN_bn2bin(dh->g,data);
	/* printf("Generator:\n%s\n",hex(data,BN_num_bytes(dh->g))); */
	data += 128;
	BN_bn2bin(dh->pub_key,data);
	/* printf("PubK:\n%s\n",hex(data,BN_num_bytes(dh->pub_key))); */
	data += 128;
	rand_get(seed,128);
	memcpy(data,seed,128);

	FLAG_CLR(link->lflag);
	FLAG_SET(link->lflag,PACKET_LINK_NBND);

	FLAG_CLR(link->nflag);
	FLAG_SET(link->nflag,PACKET_NODE_INIT);

	link->sockfd = s;

	link->write(link,&buf[0],4+(128*4));

	/*bzero(buf,4096);*/
	data = &buf[0];
	packet = &buf[2048];

	link->read(link,&buf[0],129);

	DH_compute_key(&buf[2048],BN_bin2bn(&buf[1],(*data+1),NULL),dh);
	/*buf[2048-128] =*/

	/*printf("Secret:\n%s\n",hex(&buf[2048],64));*/

	prf_expand(prf,512,&buf[2048],BN_num_bytes(dh->pub_key),seed,128);

	data = prf;

	/* printf("\nCipher Key:\n%s\n",hex(data,16)); */
	cipher_key = data;
	data += 16;

	/* printf("HMAC Key Hash:\n%s\n",hex(data,16)); */
	hmac_key = data;
	data += 16;

	/* printf("IV:\n%s\n",hex(data,16)); */
	mcrypt_generic_init(td,cipher_key,16,data);
	data += 16;
	/* printf("Start sequence: %i\n",ntohs(*(unsigned short int *)data)); */

	bzero(buf,129);

	FLAG_CLR(buf[0]);
	FLAG_SET(buf[0],PACKET_LINK_NBND);

	FLAG_CLR(buf[NODE_FLAG_POS(0)]);
	FLAG_SET(buf[NODE_FLAG_POS(0)],PACKET_NODE_INIT);

	*(unsigned short int *)(buf+NODE_SEQ_POS(0)) = *(unsigned short int *)data;

	strncpy(&buf[NODE_DATA_POS(0)],"here is some data\n",20);


	HMAC(EVP_sha1(),hmac_key,16,(buf+NODE_HASH_BEG(0)),NODE_HASH_LEN(0),&buf[2048],(int *)(buf+2096));

	/*SHA1(&buf[NODE_HASH_BEG(0)],NODE_HASH_LEN(0),&buf[2048]);*/

	xor(&buf[NODE_MAC_POS(0)],&buf[2048],&buf[2048+10],10);

	/*printf("MAC: %s\n",hex(&buf[NODE_MAC_POS(0)],10));*/
	printf("MAC:\n");
	PRINT_BYTES(stdout,&buf[NODE_MAC_POS(0)],10);


	/*printf("Plaintext:\n%s\n",hex(buf,129));*/
	printf("Plaintext:\n");
	PRINT_BYTES(stdout,buf,129);

	mcrypt_generic(td,&buf[NODE_ENC_BEG(0)],NODE_ENC_LEN(0));

	/*printf("Ciphertext:\n%s\n",hex(buf,129));*/
	printf("Ciphertext:\n");
	PRINT_BYTES(stdout,buf,129);

	memcpy(&link->sendbuf[0],&buf[0],129);

	link->writep(link);
	link->writep(link);

 }